/*
    File:       MesaRenderer.h

    Function:	

    Author:     Andrew Willmott

    Copyright:  (c) 1999-2000, Andrew Willmott
*/

#ifndef __MesaRenderer__
#define __MesaRenderer__

#include "gcl/GCLConfig.h"

#ifdef GCL_MESA
#include "gcl/GLRenderer.h"
#include "GL/osmesa.h"

class MesaRenderer : public GLRenderer
// offscreen canvas you can draw into 
{
public:
	
	MesaRenderer() : GLRenderer() {};
	~MesaRenderer();

	Void			Init(RGBAImage &img);
	Void			MakeCurrent();

protected:
	RGBAImage		*outImage;
	OSMesaContext	mesaContext;
};

#else
class MesaRenderer;
#endif

#endif

