#include "SVL.h"

void Test(Vec2 a, Vec3 b, Vec4 c)
{
	cout << a << b << c << endl << endl;
}

void AssignmentTest()
{
	Vec2 v2 = vl_one;
	Vec3 v3 = vl_one;
	Vec4 v4 = vl_one;
	Vec  vv(10, vl_one);
	Mat2 m2 = vl_I;
	Mat3 m3 = vl_I;
	Mat4 m4 = vl_one;
	Mat  mm(10,6); mm = vl_I;

	cout << "--- assignment test ----------------" << endl << endl;
	cout << v2 << v3 << v4 << vv << endl;
	cout << m2 << m3 << m4 << mm << endl;
		
	Test(vl_zero, vl_y, vl_one);
}

void TransformTest()
{
	Mat4 m(1.0, 2.0, 3.0, 4.0, 
		5.0, 6.0, 7.0, 8.0, 
		9.0, 10.0, 11.0, 12.0, 
		13.0, 14.0, 15.0, 16.0);
	Vec3 v(1.0, 2.0, 3.0);

	cout << "--- transform test ----------------" << endl << endl;

	cout << proj(m * Vec4(v, 1.0)) << endl;
	cout << xform(m, v) << endl;

	v = vl_x;
	cout << xform(HRot4(vl_y, -vl_halfPi), v) << endl;
	cout << Rot3(vl_y, -vl_halfPi) * v << endl;
	cout << proj(HTrans3(vl_y) * Vec3(1.0, 0.0, 1.0)) << endl;
}

int main()
{
	AssignmentTest();
	TransformTest();
	return(0);
}
