/*
	File:		Examiner.h

	Function:	Provides 2D function plot

	Author:		Andrew Willmott

    Copyright:  (c) 1998-2000, Andrew Willmott
*/

#ifndef __Examiner__
#define __Examiner__


#include "RadPane.h"
#include "gcl/Plot2D.h"
#include "theForms.h"

class Examiner : public PatchViewForm
{
public:
	Void 			Init(FormsGraphicsSystem &gs, RadScenePane *mainPane);
	Void			Event(FL_OBJECT *object);
	Void			BuildPlot();
	Void			SampleDiff();
	Void			SampleAdd();
	Void			Dump(ostream &s);
	
	ScenePane		plotPane;
	scScenePtr		plotScene;
	scTransform 	*scaler;
	scColour		*plotColour;
	scPlot2D		*plot;
	RadScenePane 	*radPane;
};

#endif
