/*
    File:       GenLink.h

    Function:	

    Author:     Andrew Willmott

    Copyright:  (c) 2000, Andrew Willmott
*/

#ifndef __GenLink__
#define __GenLink__

#include "HRLink.h"

class GenLink : public HRLink
{
public:
	HRLink			*New()
					{ return new GenLink; };

	RefChoice		RefineOracle();

	Bool			CalcTransport();
	Bool			CalcVisibility(HRLink *parent, Bool rv);
	Void			Gather();
	GCLReal			Error();
	GCLReal			BFAError();

	GCLReal			Strength() { return(transport); };
	
	// fields
	GCLReal			transport;
	GCLReal			error;
};

#endif
